/*
 * Copyright 1992 John L. Cwikla
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appears in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of John L. Cwikla or
 * University of Illinois not be used in advertising or publicity
 * pertaining to distribution of the software without specific, written
 * prior permission.  John L. Cwikla and University of Illinois make no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * John L. Cwikla and University of Illinois disclaim all warranties with
 * regard to this software, including all implied warranties of
 * merchantability and fitness, in no event shall John L. Cwikla or
 * University of Illinois be liable for any special, indirect or
 * consequential damages or any damages whatsoever resulting from loss of
 * use, data or profits, whether in an action of contract, negligence or
 * other tortious action, arising out of or in connection with the use or
 * performance of this software.
 *
 * Author:
 * 	John L. Cwikla
 * 	Materials Research Laboratory Center for Computation
 * 	University Of Illinois at Urbana-Champaign
 *	104 S. Goodwin
 * 	Urbana, IL 61801
 * 
 * 	cwikla@uimrl7.mrl.uiuc.edu
 */

#ifndef IMAGEP__H
#define IMAGEP__H

/*
** Image Widget
*/

#include <X11/IntrinsicP.h>
#include <X11/CoreP.h>
#include "Image.h"

typedef struct _ImagePart
{
  int width;       
  int height;
  int srcX;        /* This is the left Visible image coordinate */ 
  int srcY;        /* This is the top Visisible image coordinate */
  int destX;       /* This is where the srcX should be placed in the window */
  int destY;       /* This is where the srcY should be placed in the window */
  int gravity;
  Visual *visual;
  XtPointer data;
  GC gc;
  XtCallbackList selectCallback;
  XImage *ximage;
} ImagePart, *ImagePartPtr;

typedef struct _ImageRec
{
  CorePart core;
  ImagePart image;
} ImageRec, *ImagePtr;

typedef struct _ImageClassPart
{
  int empty;
} ImageClassPart;

typedef struct _ImageClassRec
{
  CoreClassPart core_class;	
  ImageClassPart image_class;
} ImageClassRec, *ImageClassPtr;

extern ImageClassRec imageClassRec;

#endif /* IMAGEP__H */
